Torque2D Reference

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions | Protected Attributes | Friends | List of all members
b2PrismaticJoint Class Reference

`#include <b2PrismaticJoint.h>`

Inheritance diagram for b2PrismaticJoint:

## Public Member Functions
b2Vec2 | GetAnchorA () const
| Get the anchor point on bodyA in world coordinates. More...
b2Vec2 | GetAnchorB () const
| Get the anchor point on bodyB in world coordinates. More...
b2Vec2 | GetReactionForce (float32 inv_dt) const
| Get the reaction force on bodyB at the joint anchor in Newtons. More...
float32 | GetReactionTorque (float32 inv_dt) const
| Get the reaction torque on bodyB in N*m. More...
const b2Vec2 & | GetLocalAnchorA () const
| The local anchor point relative to bodyA's origin. More...
const b2Vec2 & | GetLocalAnchorB () const
| The local anchor point relative to bodyB's origin. More...
const b2Vec2 & | GetLocalAxisA () const
| The local joint axis relative to bodyA. More...
float32 | GetReferenceAngle () const
| Get the reference angle. More...
float32 | GetJointTranslation () const
| Get the current joint translation, usually in meters. More...
float32 | GetJointSpeed () const
| Get the current joint translation speed, usually in meters per second. More...
bool | IsLimitEnabled () const
| Is the joint limit enabled? More...
void | EnableLimit (bool flag)
| Enable/disable the joint limit. More...
float32 | GetLowerLimit () const
| Get the lower joint limit, usually in meters. More...
float32 | GetUpperLimit () const
| Get the upper joint limit, usually in meters. More...
void | SetLimits (float32 lower, float32 upper)
| Set the joint limits, usually in meters. More...
bool | IsMotorEnabled () const
| Is the joint motor enabled? More...
void | EnableMotor (bool flag)
| Enable/disable the joint motor. More...
void | SetMotorSpeed (float32 speed)
| Set the motor speed, usually in meters per second. More...
float32 | GetMotorSpeed () const
| Get the motor speed, usually in meters per second. More...
void | SetMaxMotorForce (float32 force)
| Set the maximum motor force, usually in N. More...
float32 | GetMaxMotorForce () const
float32 | GetMotorForce (float32 inv_dt) const
| Get the current motor force given the inverse time step, usually in N. More...
void | Dump ()
| Dump to b2Log. More...
Public Member Functions inherited from b2Joint
b2JointType | GetType () const
| Get the type of the concrete joint. More...
b2Body * | GetBodyA ()
| Get the first body attached to this joint. More...
b2Body * | GetBodyB ()
| Get the second body attached to this joint. More...
b2Joint * | GetNext ()
| Get the next joint the world joint list. More...
const b2Joint * | GetNext () const
void * | GetUserData () const
| Get the user data pointer. More...
void | SetUserData (void *data)
| Set the user data pointer. More...
bool | IsActive () const
| Short-cut function to determine if either body is inactive. More...
bool | GetCollideConnected () const
virtual void | ShiftOrigin (const b2Vec2 &newOrigin)
| Shift the origin for any points stored in world coordinates. More...

## Protected Member Functions
| b2PrismaticJoint (const b2PrismaticJointDef *def)
void | InitVelocityConstraints (const b2SolverData &data)
void | SolveVelocityConstraints (const b2SolverData &data)
bool | SolvePositionConstraints (const b2SolverData &data)
Protected Member Functions inherited from b2Joint
| b2Joint (const b2JointDef *def)
virtual | ~b2Joint ()

## Protected Attributes
b2Vec2 | m_localAnchorA
b2Vec2 | m_localAnchorB
b2Vec2 | m_localXAxisA
b2Vec2 | m_localYAxisA
float32 | m_referenceAngle
b2Vec3 | m_impulse
float32 | m_motorImpulse
float32 | m_lowerTranslation
float32 | m_upperTranslation
float32 | m_maxMotorForce
float32 | m_motorSpeed
bool | m_enableLimit
bool | m_enableMotor
b2LimitState | m_limitState
int32 | m_indexA
int32 | m_indexB
b2Vec2 | m_localCenterA
b2Vec2 | m_localCenterB
float32 | m_invMassA
float32 | m_invMassB
float32 | m_invIA
float32 | m_invIB
b2Vec2 | m_axis
b2Vec2 | m_perp
float32 | m_s1
float32 | m_s2
float32 | m_a1
float32 | m_a2
b2Mat33 | m_K
float32 | m_motorMass
Protected Attributes inherited from b2Joint
b2JointType | m_type
b2Joint * | m_prev
b2Joint * | m_next
b2JointEdge | m_edgeA
b2JointEdge | m_edgeB
b2Body * | m_bodyA
b2Body * | m_bodyB
int32 | m_index
bool | m_islandFlag
bool | m_collideConnected
void * | m_userData

## Friends
class | b2Joint
class | b2GearJoint

## Additional Inherited Members
Static Protected Member Functions inherited from b2Joint
static b2Joint * | Create (const b2JointDef *def, b2BlockAllocator *allocator)
static void | Destroy (b2Joint *joint, b2BlockAllocator *allocator)

## Detailed Description

A prismatic joint. This joint provides one degree of freedom: translation along an axis fixed in bodyA. Relative rotation is prevented. You can use a joint limit to restrict the range of motion and a joint motor to drive the motion or to model joint friction.

## Constructor & Destructor Documentation

b2PrismaticJoint | ( | const b2PrismaticJointDef * | def | ) |
| protected

## Member Function Documentation

void Dump | ( |  | ) |
| virtual

Dump to b2Log.

Reimplemented from b2Joint.

void EnableLimit | ( | bool | flag | ) |

Enable/disable the joint limit.

void EnableMotor | ( | bool | flag | ) |

Enable/disable the joint motor.

b2Vec2 GetAnchorA | ( |  | ) | const
| virtual

Get the anchor point on bodyA in world coordinates.

Implements b2Joint.

b2Vec2 GetAnchorB | ( |  | ) | const
| virtual

Get the anchor point on bodyB in world coordinates.

Implements b2Joint.

float32 GetJointSpeed | ( |  | ) | const

Get the current joint translation speed, usually in meters per second.

float32 GetJointTranslation | ( |  | ) | const

Get the current joint translation, usually in meters.

const b2Vec2& GetLocalAnchorA | ( |  | ) | const
| inline

The local anchor point relative to bodyA's origin.

const b2Vec2& GetLocalAnchorB | ( |  | ) | const
| inline

The local anchor point relative to bodyB's origin.

const b2Vec2& GetLocalAxisA | ( |  | ) | const
| inline

The local joint axis relative to bodyA.

float32 GetLowerLimit | ( |  | ) | const

Get the lower joint limit, usually in meters.

float32 GetMaxMotorForce | ( |  | ) | const
| inline

float32 GetMotorForce | ( | float32 | inv_dt | ) | const

Get the current motor force given the inverse time step, usually in N.

float32 GetMotorSpeed | ( |  | ) | const
| inline

Get the motor speed, usually in meters per second.

b2Vec2 GetReactionForce | ( | float32 | inv_dt | ) | const
| virtual

Get the reaction force on bodyB at the joint anchor in Newtons.

Implements b2Joint.

float32 GetReactionTorque | ( | float32 | inv_dt | ) | const
| virtual

Get the reaction torque on bodyB in N*m.

Implements b2Joint.

float32 GetReferenceAngle | ( |  | ) | const
| inline

Get the reference angle.

float32 GetUpperLimit | ( |  | ) | const

Get the upper joint limit, usually in meters.

void InitVelocityConstraints | ( | const b2SolverData & | data | ) |
| protected virtual

Implements b2Joint.

bool IsLimitEnabled | ( |  | ) | const

Is the joint limit enabled?

bool IsMotorEnabled | ( |  | ) | const

Is the joint motor enabled?

void SetLimits | ( | float32 | lower,
|  | float32 | upper
| ) |  |

Set the joint limits, usually in meters.

void SetMaxMotorForce | ( | float32 | force | ) |

Set the maximum motor force, usually in N.

void SetMotorSpeed | ( | float32 | speed | ) |

Set the motor speed, usually in meters per second.

bool SolvePositionConstraints | ( | const b2SolverData & | data | ) |
| protected virtual

Implements b2Joint.

void SolveVelocityConstraints | ( | const b2SolverData & | data | ) |
| protected virtual

Implements b2Joint.

## Friends And Related Function Documentation

friend class b2GearJoint
| friend

friend class b2Joint
| friend

## Member Data Documentation

float32 m_a1
| protected

float32 m_a2
| protected

b2Vec2 m_axis
| protected

bool m_enableLimit
| protected

bool m_enableMotor
| protected

b2Vec3 m_impulse
| protected

int32 m_indexA
| protected

int32 m_indexB
| protected

float32 m_invIA
| protected

float32 m_invIB
| protected

float32 m_invMassA
| protected

float32 m_invMassB
| protected

b2Mat33 m_K
| protected

b2LimitState m_limitState
| protected

b2Vec2 m_localAnchorA
| protected

b2Vec2 m_localAnchorB
| protected

b2Vec2 m_localCenterA
| protected

b2Vec2 m_localCenterB
| protected

b2Vec2 m_localXAxisA
| protected

b2Vec2 m_localYAxisA
| protected

float32 m_lowerTranslation
| protected

float32 m_maxMotorForce
| protected

float32 m_motorImpulse
| protected

float32 m_motorMass
| protected

float32 m_motorSpeed
| protected

b2Vec2 m_perp
| protected

float32 m_referenceAngle
| protected

float32 m_s1
| protected

float32 m_s2
| protected

float32 m_upperTranslation
| protected

The documentation for this class was generated from the following files:

- Box2D/Dynamics/Joints/b2PrismaticJoint.h
- Box2D/Dynamics/Joints/b2PrismaticJoint.cpp